/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOCARD                                                 */
/* Tabela : TIPOCARD                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 22/12/2004 - Henrique Dias Borges                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TIPOCARD
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOCARD FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTCAR := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NMTIPOCARD,0)   <> NVL(:NEW.NMTIPOCARD,0))   OR
         (NVL(:OLD.IDTPCARDATIV,0) <> NVL(:NEW.IDTPCARDATIV,0)) OR
         (NVL(:OLD.NRPASTATCARD,0) <> NVL(:NEW.NRPASTATCARD,0)) THEN
         :NEW.DTULTATUTCAR := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPOCARD', '', 'CDFILCENTPME='||:OLD.CDFILCENTPME||';CDTIPOCARD='||:OLD.CDTIPOCARD||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPOCARD MODIFY DTULTATUTCAR DEFAULT SYSDATE
/

