/* Tabela BASECALC: Base de Clculo */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela BASECALC */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Base de Clculo,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIS_BASECALC
AFTER DELETE OR INSERT OR UPDATE
ON BASECALC FOR EACH ROW
DECLARE
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(300);
  V_DTOPER    DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN
      IF :OLD.CDENCARGO IS NOT NULL THEN
         V_DESC := V_DESC || 'Enca=' || :OLD.CDENCARGO;
      END IF;

      IF :OLD.CDIMPOBCALC IS NOT NULL THEN
         V_DESC := V_DESC || ' Impo=' || :OLD.CDIMPOBCALC;
      END IF;

      IF :OLD.IDTIPOBCALC IS NOT NULL THEN
         V_DESC := V_DESC || ' TipoBCalc=' || :OLD.IDTIPOBCALC;
      END IF;

      IF :OLD.CDCFOPIMPO IS NOT NULL THEN
         V_DESC := V_DESC || ' CFOpImpo=' || :OLD.CDCFOPIMPO;
      END IF;

      IF :OLD.CDCSTIMPO IS NOT NULL THEN
         V_DESC := V_DESC || ' CSTImpo=' || :OLD.CDCSTIMPO;
      END IF;

      IF :OLD.CDFISCIMPO IS NOT NULL THEN
         V_DESC := V_DESC || ' CFImpo=' || :OLD.CDFISCIMPO;
      END IF;

      V_TIPO := '3';
      V_ITPESQ := :OLD.CDIMPOSTO||:OLD.NRSEQUBCALC;
   ELSE
      IF UPDATING THEN
        IF (:OLD.CDENCARGO   <> :NEW.CDENCARGO)   OR
           (:OLD.CDIMPOBCALC <> :NEW.CDIMPOBCALC) OR
           (:OLD.IDTIPOBCALC <> :NEW.IDTIPOBCALC) OR
           (:OLD.CDCFOPIMPO  <> :NEW.CDCFOPIMPO)  OR
           (:OLD.CDCSTIMPO   <> :NEW.CDCSTIMPO)   OR
           (:OLD.CDFISCIMPO  <> :NEW.CDFISCIMPO)  THEN

            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDIMPOSTO||:OLD.NRSEQUBCALC;
         END IF;
      ELSE
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDIMPOSTO||:NEW.NRSEQUBCALC;
      END IF;

      IF :NEW.CDENCARGO IS NOT NULL THEN
         V_DESC := V_DESC || 'Enca=' || :NEW.CDENCARGO;
      END IF;

      IF :NEW.CDIMPOBCALC IS NOT NULL THEN
         V_DESC := V_DESC || ' Impo=' || :NEW.CDIMPOBCALC;
      END IF;

      IF :NEW.IDTIPOBCALC IS NOT NULL THEN
         V_DESC := V_DESC || ' TipoBCalc=' || :NEW.IDTIPOBCALC;
      END IF;

      IF :NEW.CDCFOPIMPO IS NOT NULL THEN
         V_DESC := V_DESC || ' CFOpImpo=' || :NEW.CDCFOPIMPO;
      END IF;

      IF :NEW.CDCSTIMPO IS NOT NULL THEN
         V_DESC := V_DESC || ' CSTImpo=' || :NEW.CDCSTIMPO;
      END IF;

      IF :NEW.CDFISCIMPO IS NOT NULL THEN
         V_DESC := V_DESC || ' CFImpo=' || :NEW.CDFISCIMPO;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('BASECALC',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIS_BASECALC','5.20.000'); END;
/

